/*
 * Swagger Petstore
 * This is a sample server Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/).  For this sample, you can use the api key `special-key` to test the authorization filters.
 *
 * OpenAPI spec version: 1.0.5
 * Contact: apiteam@swagger.io
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.model.User;
import org.junit.Assert;
import org.junit.Test;
import org.junit.Ignore;

import com.github.tomakehurst.wiremock.WireMockServer;
import com.github.tomakehurst.wiremock.core.WireMockConfiguration;
import java.net.HttpURLConnection;
import org.junit.AfterClass;
import org.junit.BeforeClass;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import static com.github.tomakehurst.wiremock.client.WireMock.*;
/**
 * API tests for UserApi
 */
public class UserApiTest {

    private final UserApi api = new UserApi();
    private static WireMockServer wireMockServer;

    public UserApiTest() {
        api.getApiClient().setBasePath("http://localhost:" + wireMockServer.port());
    }

    @BeforeClass
    public static void setUp() {
        wireMockServer = new WireMockServer(WireMockConfiguration.wireMockConfig().dynamicPort());
        wireMockServer.start();

        configureFor(wireMockServer.port());

        stubFor(post(urlPathMatching("/user"))
                .willReturn(aResponse()
                        .withStatus(HttpURLConnection.HTTP_OK)));

        stubFor(post(urlPathMatching("/user/createWithArray"))
                .willReturn(aResponse()
                        .withStatus(HttpURLConnection.HTTP_OK)));

        stubFor(post(urlPathMatching("/user/createWithList"))
                .willReturn(aResponse()
                        .withStatus(HttpURLConnection.HTTP_OK)));

        stubFor(delete(urlPathMatching("/user/user1"))
                .willReturn(aResponse()
                        .withStatus(HttpURLConnection.HTTP_OK)));

        stubFor(get(urlPathMatching("/user/user1"))
                .willReturn(aResponse()
                        .withStatus(HttpURLConnection.HTTP_OK)
                        .withBody("{\"id\":10,\"username\":\"user1\"}")));

    }

    @AfterClass
    public static void tearDown() {
        wireMockServer.stop();
    }


    /**
     * Create user
     *
     * This can only be done by the logged in user.
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void createUserTest() throws Exception {
        User body = new User().id(10L).username("user1");
        api.createUser(body);

        verify(exactly(1), postRequestedFor(urlEqualTo("/user")));
    }

    /**
     * Creates list of users with given input array
     *
     *
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void createUsersWithListInputTest() throws Exception {
        User user = new User().id(10L).username("user1");
        List<User> body = Arrays.asList(user);
        api.createUsersWithListInput(body);

        verify(exactly(1), postRequestedFor(urlEqualTo("/user/createWithList")));
    }

    /**
     * Delete user
     *
     * This can only be done by the logged in user.
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void deleteUserTest() throws Exception {
        String username = "user1";
        api.deleteUser(username);

        verify(exactly(1), deleteRequestedFor(urlEqualTo("/user/user1")));
    }

    /**
     * Get user by user name
     *
     *
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void getUserByNameTest() throws Exception {
        String username = "user1";
        User response = api.getUserByName(username);

        Assert.assertEquals(10L, response.getId().longValue());
        Assert.assertEquals("user1", response.getUsername());

        verify(exactly(1), getRequestedFor(urlEqualTo("/user/user1")));
    }
}
